#if !defined(AFX_FRACWND_H__AA4A322A_6E3B_4BFB_9D90_968EAB3E75AE__INCLUDED_)
#define AFX_FRACWND_H__AA4A322A_6E3B_4BFB_9D90_968EAB3E75AE__INCLUDED_
/*########################################################################
	FracWnd.h

	Copyright 2002 Mark Williams, all rights reserved.
	Contact: mark@extrabit.com
	http://www.extrabit.com

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

########################################################################*/

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CFracWnd window

class FractalImage ;
class Palette ;


/**	This is a derived CWnd class which is used to display the
 *	fractal image.
 *	This window fills the entire client area of the frame window (CMainFrame).
 */
class CFracWnd : public CWnd
{
// Construction
public:
	CFracWnd();

// Attributes
public:
	void set_image (FractalImage*) ;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFracWnd)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFracWnd();

	// Generated message map functions
protected:
	//{{AFX_MSG(CFracWnd)
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	void update_bitmap (void) ;
	void construct (CDC* p_dc, int width, int height) ;
	void draw_cbitmap (CDC* p_dc,
						const CRect& image_rect_v,
						HBITMAP bitmap, DWORD rasterop) ;
	void zoom_in (const CRect&) ;

private:
	/** Image being shown. */
	FractalImage* m_image ;

	/**	Offscreen image in which RGB pixel values are set. */
	HBITMAP m_rgb_bitmap ;

	// Zooming in interaction.
	CPoint m_mouse_down ;
	CPoint m_mouse_curr ;
	bool m_in_drag ;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FRACWND_H__AA4A322A_6E3B_4BFB_9D90_968EAB3E75AE__INCLUDED_)
