#ifndef ImageGen_H
#define ImageGen_H
/*########################################################################
	File:			ImageGen.h
	Creation date:	6th June 2002

	Copyright 2002 Mark Williams, all rights reserved.
	Contact: mark@extrabit.com
	http://www.extrabit.com

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

########################################################################*/

/*########################################################################
	Headers
########################################################################*/

/*########################################################################
	Declarations
########################################################################*/

/*########################################################################
	Class Definition
########################################################################*/

/**	Pure virtual base class that provides an interface to the image generators,
 *	FastImageGen and ProgressiveImageGen.
 */
class ImageGen
{
public:
	virtual ~ImageGen (void) {}

	virtual void init (void) = 0 ;
	virtual void restart (void) = 0 ;
	virtual bool process (void) = 0 ;
	virtual bool inq_done (void) const = 0 ;
	virtual int inq_progress (void) const = 0 ;
} ;


/*########################################################################
	End
########################################################################*/
#endif
